stages:
  - build
  - package
  - deploy

variables:
  GIT_SUBMODULE_STRATEGY: recursive

#-----------------------------------------------------------
#                      TEMPLATES
#-----------------------------------------------------------

.build_win_template: &win_build_definition
  stage: build
  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.1.1-windows2019
  tags:
    - imv-windows-docker
  artifacts:
    expire_in: 4 hours
    paths:
      - "$GENERATOR $ARCH/source/$CONFIG/*.lib"
  script:
    - bash ./build.sh "$GENERATOR" "$ARCH" "$CONFIG"


.build_lnx_template: &lnx_build_definition
  stage: build
  artifacts:
    expire_in: 4 hours
    paths:
      - "$OS $GENERATOR $ARCH/$CONFIG/source/*.a"
  script:
    - bash ./build.sh "$GENERATOR" "$ARCH" "$CONFIG" "$OS"

#-----------------------------------------------------------
#                      WINDOWS BUILDS
#-----------------------------------------------------------

build_win_vs2019_x64_rel:
  <<: *win_build_definition

  variables:
    GENERATOR: "Visual Studio 16 2019"
    ARCH: "x64"
    CONFIG: "Release"

build_win_vs2019_x64_dbg:
  <<: *win_build_definition

  variables:
    GENERATOR: "Visual Studio 16 2019"
    ARCH: "x64"
    CONFIG: "Debug"
    
build_win_vs2019_x86_rel:
  <<: *win_build_definition

  variables:
    GENERATOR: "Visual Studio 16 2019"
    ARCH: "x86"
    CONFIG: "Release"

build_win_vs2019_x86_dbg:
  <<: *win_build_definition

  variables:
    GENERATOR: "Visual Studio 16 2019"
    ARCH: "x86"
    CONFIG: "Debug"

#-----------------------------------------------------------
#                      UBUNTU 20.04 BUILDS
#-----------------------------------------------------------

build_ubuntu20_04_x64_rel:
  <<: *lnx_build_definition

  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.0.0-ubuntu20_04
  variables:
    GENERATOR: "Unix Makefiles"
    ARCH: "x64"
    CONFIG: "Release"
    OS: "Ubuntu20_04"

build_ubuntu20_04_x64_dbg:
  <<: *lnx_build_definition

  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.0.0-ubuntu20_04
  variables:
    GENERATOR: "Unix Makefiles"
    ARCH: "x64"
    CONFIG: "Debug"
    OS: "Ubuntu20_04"

#-----------------------------------------------------------
#                      UBUNTU 18.04 BUILDS
#-----------------------------------------------------------

build_ubuntu18_04_x64_rel:
  <<: *lnx_build_definition

  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.5.0-ubuntu18_04
  variables:
    GENERATOR: "Unix Makefiles"
    ARCH: "x64"
    CONFIG: "Release"
    OS: "Ubuntu18_04"

build_ubuntu18_04_x64_dbg:
  <<: *lnx_build_definition

  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.5.0-ubuntu18_04
  variables:
    GENERATOR: "Unix Makefiles"
    ARCH: "x64"
    CONFIG: "Debug"
    OS: "Ubuntu18_04"

#-----------------------------------------------------------
#                      UBUNTU 16.04 BUILDS
#-----------------------------------------------------------

# build_ubuntu16_04_arm64_rel:
#   <<: *lnx_build_definition

#   tags:
#     - arm64
#     - ubuntu-16-04
#   variables:
#     GENERATOR: "Unix Makefiles"
#     ARCH: "arm64"
#     CONFIG: "Release"
#     OS: "Ubuntu16_04"

# build_ubuntu16_04_arm64_dbg:
#   <<: *lnx_build_definition

#   tags:
#     - arm64
#     - ubuntu-16-04
#   variables:
#     GENERATOR: "Unix Makefiles"
#     ARCH: "arm64"
#     CONFIG: "Debug"
#     OS: "Ubuntu16_04"

#-----------------------------------------------------------
#                      CENTOS 7 BUILDS
#-----------------------------------------------------------

build_centos7_x64_rel:
  <<: *lnx_build_definition

  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.1.3-centos7
  variables:
    GENERATOR: "Unix Makefiles"
    ARCH: "x64"
    CONFIG: "Release"
    OS: "CentOS7"

build_centos7_x64_dbg:
  <<: *lnx_build_definition

  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.1.3-centos7
  variables:
    GENERATOR: "Unix Makefiles"
    ARCH: "x64"
    CONFIG: "Debug"
    OS: "CentOS7"

#-----------------------------------------------------------
#                      PACKAGE
#-----------------------------------------------------------

package:
  stage: package
  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.5.0-ubuntu18_04
  script:
    - pushd NuGet
    - nuget pack
    - bash ./check_package_exists.sh
    - popd
  artifacts:
    expire_in: 4 hours
    paths:
      - "NuGet/*.nupkg"

#-----------------------------------------------------------
#                      DEPLOY
#-----------------------------------------------------------

deploy:
  stage: deploy
  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.5.0-ubuntu18_04
  script:
    - pushd NuGet
    - nuget source Add -Name gitlab -Source "$CI_SERVER_URL/api/v4/projects/$CI_PROJECT_ID/packages/nuget/index.json" -UserName gitlab-ci-token -Password $CI_JOB_TOKEN
    - nuget push *.nupkg -Source gitlab
    - popd
  only:
    - master
